#procedure ParFrac(par)
****************************************************************************
**
**  Filename:
**            ParFrac.prc
**
**  Authors: 
**            Sven O. Moch and Peter Uwer
**
**  Purpose: 
**            Partial fractioning of denominators.
**
**  Comments:
**
**
**  Revision: 
**            $Id: ParFrac.prc,v 1.0 2005/08/02 10:09:54 puwer Exp $
**
**            $Log: ParFrac.prc,v $
**            Revision 1.0  2005/08/02 10:09:54  puwer
**            Initial revision
**
**
****************************************************************************
#if `par' == 1
	repeat id x1*den(1-x1-x2) = -1 + num(1-x2)*den(1-x1-x2);
	repeat id num(x?)*den(x?) = 1;
	id num(x?) = x;

	.sort: ParFrac-`par'a;

	id den(x1?) = den(x1,1);
	repeat id den(x1?,n0?)*den(x1?,n1?) = den(x1,n0+n1);

	id den(x1+x2,n0?)*den(1-x1-x2,n1?) =  
	  sum_(jjj,1,n0,binom_(n0+n1-1-jjj,n1-1)*den(x1+x2,jjj)) 
		+ sum_(jjj,1,n1,binom_(n0+n1-1-jjj,n0-1)*den(1-x1-x2,jjj));

	id den(1-x1,n0?)*den(1-x1-x2,n1?) =  
		+ sign_(n1)*sum_(jjj,1,n0,binom_(n0+n1-1-jjj,n1-1)*den(1-x1,jjj)/x2^(n0+n1-jjj)) 
		+ sum_(jjj,1,n1,sign_(n1-jjj)*binom_(n0+n1-1-jjj,n0-1)*den(1-x1-x2,jjj)/x2^(n0+n1-jjj));

	id den(1-x2,n0?)*den(1-x1-x2,n1?) =  
		+ sign_(n1)*sum_(jjj,1,n0,binom_(n0+n1-1-jjj,n1-1)*den(1-x2,jjj)/x1^(n0+n1-jjj)) 
		+ sum_(jjj,1,n1,sign_(n1-jjj)*binom_(n0+n1-1-jjj,n0-1)*den(1-x1-x2,jjj)/x1^(n0+n1-jjj));

	id den(x1?,n0?) = den(x1)^n0;

	.sort: ParFrac-`par'b;

	repeat id x1*den(x1+x2) = 1 - x2*den(x1+x2);
	repeat id x1*den(1-x1) = -1 + den(1-x1);
	repeat id x2*den(1-x2) = -1 + den(1-x2);

	id den(x1?) = den(x1,1);
	repeat id den(x1?,n0?)*den(x1?,n1?) = den(x1,n0+n1);

	id x1^n0?neg_*den(x1+x2,n1?) =
		+ sum_(jjj,1,-n0,sign_(n0-jjj)*binom_(-n0+n1-1-jjj,n1-1)*x1^-jjj/x2^(-n0+n1-jjj)) 
		+ sign_(n0)*sum_(jjj,1,n1,binom_(-n0+n1-1-jjj,-n0-1)*den(x1+x2,jjj)/x2^(-n0+n1-jjj));
	id x1^n0?neg_*den(1-x1,n1?) =  
	  sum_(jjj,1,-n0,binom_(-n0+n1-1-jjj,n1-1)*x1^-jjj) 
		+ sum_(jjj,1,n1,binom_(-n0+n1-1-jjj,-n0-1)*den(1-x1,jjj));
	id x2^n0?neg_*den(1-x2,n1?) =  
	  sum_(jjj,1,-n0,binom_(-n0+n1-1-jjj,n1-1)*x2^-jjj) 
		+ sum_(jjj,1,n1,binom_(-n0+n1-1-jjj,-n0-1)*den(1-x2,jjj));

	id den(x1?,n0?) = den(x1)^n0;

	.sort: ParFrac-`par'c;

	repeat id den(1-x1)*den(x1+x2) = den(1+x2)*den(1-x1) + den(1+x2)*den(x1+x2);
	repeat id x2*den(1+x2) = 1 - den(1+x2);
	repeat id 1/x2*den(1+x2) = 1/x2 - den(1+x2);

	repeat id den(1-x2)*den(x1+x2) = den(1+x1)*den(1-x2) + den(1+x1)*den(x1+x2);
	repeat id x1*den(1+x1) = 1 - den(1+x1);
	repeat id 1/x1*den(1+x1) = 1/x1 - den(1+x1);



#elseif `par' == 2
	repeat id x2*den(1-x1-x2) = -1 + num(1-x1)*den(1-x1-x2);
	repeat id num(x?)*den(x?) = 1;
	id num(x?) = x;

	.sort: ParFrac-`par'a;

	id den(x1?) = den(x1,1);
	repeat id den(x1?,n0?)*den(x1?,n1?) = den(x1,n0+n1);

	id den(x1+x2,n0?)*den(1-x1-x2,n1?) =  
	  sum_(jjj,1,n0,binom_(n0+n1-1-jjj,n1-1)*den(x1+x2,jjj)) 
		+ sum_(jjj,1,n1,binom_(n0+n1-1-jjj,n0-1)*den(1-x1-x2,jjj));

	id den(1-x1,n0?)*den(1-x1-x2,n1?) =  
		+ sign_(n1)*sum_(jjj,1,n0,binom_(n0+n1-1-jjj,n1-1)*den(1-x1,jjj)/x2^(n0+n1-jjj)) 
		+ sum_(jjj,1,n1,sign_(n1-jjj)*binom_(n0+n1-1-jjj,n0-1)*den(1-x1-x2,jjj)/x2^(n0+n1-jjj));

	id den(1-x2,n0?)*den(1-x1-x2,n1?) =  
		+ sign_(n1)*sum_(jjj,1,n0,binom_(n0+n1-1-jjj,n1-1)*den(1-x2,jjj)/x1^(n0+n1-jjj)) 
		+ sum_(jjj,1,n1,sign_(n1-jjj)*binom_(n0+n1-1-jjj,n0-1)*den(1-x1-x2,jjj)/x1^(n0+n1-jjj));

	id den(x1?,n0?) = den(x1)^n0;

	.sort: ParFrac-`par'b;

	repeat id x1*den(x1+x2) = 1 - x2*den(x1+x2);
	repeat id x1*den(1-x1) = -1 + den(1-x1);
	repeat id x2*den(1-x2) = -1 + den(1-x2);

	id den(x1?) = den(x1,1);
	repeat id den(x1?,n0?)*den(x1?,n1?) = den(x1,n0+n1);

	id x1^n0?neg_*den(x1+x2,n1?) =
		+ sum_(jjj,1,-n0,sign_(n0-jjj)*binom_(-n0+n1-1-jjj,n1-1)*x1^-jjj/x2^(-n0+n1-jjj)) 
		+ sign_(n0)*sum_(jjj,1,n1,binom_(-n0+n1-1-jjj,-n0-1)*den(x1+x2,jjj)/x2^(-n0+n1-jjj));
	id x1^n0?neg_*den(1-x1,n1?) =  
	  sum_(jjj,1,-n0,binom_(-n0+n1-1-jjj,n1-1)*x1^-jjj) 
		+ sum_(jjj,1,n1,binom_(-n0+n1-1-jjj,-n0-1)*den(1-x1,jjj));

	id x2^n0?neg_*den(1-x2,n1?) =  
	  sum_(jjj,1,-n0,binom_(-n0+n1-1-jjj,n1-1)*x2^-jjj) 
		+ sum_(jjj,1,n1,binom_(-n0+n1-1-jjj,-n0-1)*den(1-x2,jjj));

	id den(x1?,n0?) = den(x1)^n0;

#endif

#endprocedure
*************************************************************************
* Local variables:
* modify-insert-tag: nil
* comment-start: "*"
* tab-width: 2
* End:
*************************************************************************
