#procedure SimplifySumArgs
****************************************************************************
**
**  Filename:
**            SimplifySumArgs
**
**  Authors: 
**            Sven O. Moch and Peter Uwer
**
**  Purpose: 
**            Procedure to simplify polynomials in arguments of 
**            \keyword{S} functions. This procedure is user accessible 
**            and should be edited if optimization is needed. 
**
**  Comments:
**
**
**  Revision: 
**            $Id: SimplifySumArgs.prc,v 1.0 2005/08/02 10:09:54 puwer Exp $
**
**            $Log: SimplifySumArgs.prc,v $
**            Revision 1.0  2005/08/02 10:09:54  puwer
**            Initial revision
**
**
****************************************************************************

Argument pow;
	id num(x?) = x;
	id den(1 + x1^(-1)*x2) = x1*den(x1 + x2);
	id den(1 + x2^(-1)*x1) = x2*den(x1 + x2);
	repeat id x2*den(x1 + x2) = 1 - x1*den(x1 + x2);
EndArgument;
*
id pow(x1?,0) = 1;
id pow(1,x1?) = 1;

*
* clean up argument of S-fct.
*
Argument S;
Argument X;
	id num(x?) = x;
	id den(1 + x1^(-1)*x2) = x1*den(x1 + x2);
	id den(1 + x2^(-1)*x1) = x2*den(x1 + x2);
	repeat id x1*den(x1 + x2) = 1 - x2*den(x1 + x2);
EndArgument;
EndArgument;

#endprocedure
*
*************************************************************************
* Local variables:
* modify-insert-tag: nil
* comment-start: "*"
* tab-width: 2
* End:
*************************************************************************
