#procedure Movej(i,X)
****************************************************************************
**
**  Filename:
**            Movej.prc
**
**  Authors: 
**            Sven O. Moch and Peter Uwer
**
**  Purpose: 
**            Makes a translation of $j_i+n$ $\to$ $j_i$. The first argument
**            specifies which index $i$ of the summation variable which should be 
**            used. The shift is determined by the argument of the function 
**            specified by the second argument passed to \keyword{Movej}. 
**            
**  Comments:
**
**
**  Revision: 
**            $Id: Movej.prc,v 1.0 2005/08/02 10:09:54 puwer Exp $
**
**            $Log: Movej.prc,v $
**            Revision 1.0  2005/08/02 10:09:54  puwer
**            Initial revision
**
**
****************************************************************************
*
id  sum`i'(j`i',x1?,x2?)*`X'(x3?) = sum`i'(x1+x3,x2+x3)*replace_(j`i',j`i'-x3);
id  sum`i'(x1?,x2?) = sum`i'(j`i',x1,x2);

id  f?{den`i',fac`i',invfac`i',sign`i'}(x1?,x2?) = f(x1+x2);
id  S`i'(R(?m),X(?x1),x2?,x3?) = S`i'(R(?m),X(?x1),x2+x3);
id  pow`i'(x1?,x2?,x3?) = pow`i'(x1,x2+x3);
SplitArg,(j`i'),den`i',fac`i',invfac`i',S`i',pow`i';
id  f?{den`i',fac`i',invfac`i'}(x2?) = f(0,x2);
id  S`i'(R(?m),X(?x1),x2?) = S`i'(R(?m),X(?x1),0,x2);
id pow`i'(x1?,j`i')  = pow`i'(x1,j`i');
id pow`i'(x1?,-j`i') = pow`i'(1/x1,j`i');
id pow`i'(x1?,n1?,j`i')  = pow(x1,n1) * pow`i'(x1,j`i');
id pow`i'(x1?,n1?,-j`i') = pow(x1,n1) * pow`i'(1/x1,j`i');
repeat id pow(x?,n1?)*pow(x?,n2?) = pow(x,n1+n2);
repeat id pow`i'(x1?,j`i') * pow`i'(x2?,j`i') = pow`i'(x1*x2,j`i');
*
#endprocedure
*************************************************************************
* Local variables:
* modify-insert-tag: nil
* comment-start: "*"
* tab-width: 2
* End:
*************************************************************************
