#procedure Simplify
****************************************************************************
**
**  Filename:
**            Simplify.prc
**
**  Authors: 
**            Sven O. Moch and Peter Uwer
**
**  Purpose: 
**            Calls different simplification and normalization routines to
**            simplify or normalize the expresssions.
**
**  Comments:
**
**
**  Revision: 
**            $Id: Simplify.prc,v 1.0 2005/08/02 10:09:54 puwer Exp $
**
**            $Log: Simplify.prc,v $
**            Revision 1.0  2005/08/02 10:09:54  puwer
**            Initial revision
**
**
****************************************************************************
*
* normalization of Gamma functions 
*
#call NormalizeGam

*
* look for simplifications among factorials and Gamma functions
*
#call SimplifyFacGam
*
* expansion of Gamma functions in ep
*
#call ExpandGam(`MAXSUM')
*
* ep expansion of den functions
*
#call ExpandDen(0)
#call ExpandDen(1)

*
* cut on order
*
id acc(x?) = x;
B order,ep;
.sort
Collect acc1;
if(count(order,1)) id acc1(x?) = 1;
id 			acc1(x?) = x;
id      ep^n? = acc(ep^n);

id ep^n?*acc(x?) = acc(ep^n*x);
#do counter = 2,`MAXCOUNTER';
id z`counter'^n?*acc(x?) = acc(z`counter'^n*x);
#enddo
*
* simplification of sign functions
*
id  sign_(x?) = sign(x);
Splitarg sign;
repeat id sign(n1?,n2?,?a) = sign(n1)*sign(n2,?a);
#do counter = 0,`MAXWEIGHT'
id  sign(-j`counter') = sign(j`counter');
#enddo
repeat id sign(x?{j0,...,j`MAXWEIGHT'})*sign(x?{j0,...,j`MAXWEIGHT'}) = 1;
id sign(x?) = sign_(x);
id sign_(x?) = pow(-1,x);
repeat id pow(x?,n1?)*pow(x?,n2?) = pow(x,n1+n2);
repeat id pow(x1?,n1?{j0,...,j`MAXWEIGHT'})*pow(x2?,n1?{j0,...,j`MAXWEIGHT'}) = pow(x1*x2,n1);

#endprocedure
*************************************************************************
* Local variables:
* modify-insert-tag: nil
* comment-start: "*"
* tab-width: 2
* End:
*************************************************************************
